import { Utils, Queue } from 'solid-js'
import Handler from './Handler'

methods = {
  trigger: (property, value, notify) ->
    subs = @_child_subscriptions[property]
    if subs?.size
      Queue.queueTask(sub, value) for sub from subs
    @notify(@_target) if notify

  peek: (property) ->
    value = @_target[property]
    if Utils.isObject(value) and Object.isFrozen(value)
      value = Utils.clone(value)
      @_target[property] = value
    Handler.wrap(value)

  on: (property, fn) ->
    value = @_target[property]
    disposable = null
    if Utils.isObject(value) and not (Utils.isFunction(value) or value instanceof Element)
      handler = Handler.handler(value)
      disposable = handler.subscribe(fn)
    @_child_subscriptions[property] or= new Set()
    @_child_subscriptions[property].add(fn)
    return {unsubscribe: =>
      disposable.unsubscribe() if disposable
      @_child_subscriptions[property].delete(fn)
    }
}

Object.assign(Handler::, methods)

export default methods